> For the complete documentation index, see [llms.txt](https://docs.reaper.farm/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.reaper.farm/sdk/reaper-sdk/uniswap-utilities.md).

# Uniswap Utilities

### Create your trading route

Pass your input and output tokens to createRoute and it will return an array you can pass into a swap.

`reaper.createRoute(tokenInput:string, tokenOutput:string) => (route:array)`

### Swap

Execute a swap on any Uniswap V2 router

`reaper.swap(routerAddress:string, tokenInput:string, tokenOutput:string, toAddress:string, amountIn:uint, slippage:uint%)`\
`=> (transactionReceipt:object)`

### Add Liquidity

Add Liquidity to a Uniswap V2 pool.

`reaper.addLiquidity(exchangeAddress:string, tokenOne:string, tokenTwo:string,) => (transactionReceipt:object)`

### Retrieve a pair address

Retrieve an existing LP pair address. If the address doesn't exist, it will create one.

`reaper.getPairAddress(factoryAddress:string, tokenOne:string, tokenTwo:string) => (lpAddress:string)`


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.reaper.farm/sdk/reaper-sdk/uniswap-utilities.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
